;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of 1to1 Soccer: An Amstrad CPC Game
;;  Copyright (C) 2020 Utopia (@UtopiaRetroDev)
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see http://www.gnu.org/licenses/.
;;-------------------------------------------------------------------------------

.module Character_Manager

.include "sys/render.h.s"
.include "cpctelera.h.s"
.include "cpct_functions.h.s"
.include "man/entity.h.s"
.include "src/sprites/sprites.h.s"
.include "src/sprites/precalculated.h.s"
.include "src/sprites/menus/menu_characters_z.h.s"

.globl game_restart

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; 
;; Funcion de inicializar el menu de personaje
;;
;;   

man_character_init::

    ld  hl, #_menu_characters_z_end
    ld  de, #0xFFFF 
    call cpct_zx7b_decrunch_s_asm

    ld  de, #0xC000
    ld  c, #40
    ld  b, #27

    call cpct_getScreenPtr_asm

    ex  de, hl                              ;;metemos en de la dir de mem que nos devuelve la llamada anterior
    ld  hl, #_sprite_player_1
    ld  c, #34
    ld  b, #28

    call cpct_drawSprite_asm

    ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; 
;; Funcion de actualizar el menu de personaje
;;
;;   

man_character_run::

    ld  hl, #Key_Esc
    call cpct_isKeyPressed_asm
    jr  nz, back_menu                   ;;si pulsa ESC vuelve al menu anterior
    ld  hl, #Key_1
    call cpct_isKeyPressed_asm
    jr  nz, character_1                 ;;si esta pulsando el 1 le colocamos los datos del personaje 1
    ld  hl, #Key_2
    call cpct_isKeyPressed_asm
    jr  nz, character_2                 ;;si esta pulsando el 2 le colocamos los datos del personaje 2
    ld  hl, #Key_3
    call cpct_isKeyPressed_asm
    jr  nz, character_3                 ;;si esta pulsando el 3 le colocamos los datos del personaje 3
    ld  hl, #Key_4
    call cpct_isKeyPressed_asm
    jr  z, man_character_run            ;;si no se ha pulsado ninguna nos quedamos en bucle

    ld  hl, #draw_Sprite_Boy_Prince_Right       ;;modificamos para que el sprite del jugador 1 sea el del personaje 4
    ld  de, #draw_Sprite_Boy_Prince 
    jr  fin_change_character

    character_1:
    ld  hl, #draw_Sprite_Girl_Right             ;;modificamos para que el sprite del jugador 1 sea el del personaje 1
    ld  de, #draw_Sprite_Girl
    jr  fin_change_character

    character_2:
    ld  hl, #draw_Sprite_Boy_Right              ;;modificamos para que el sprite del jugador 1 sea el del personaje 2
    ld  de, #draw_Sprite_Boy
    jr  fin_change_character

    character_3:
    ld  hl, #draw_Sprite_Girl_Prince_Right      ;;modificamos para que el sprite del jugador 1 sea el del personaje 3
    ld  de, #draw_Sprite_Girl_Prince

    fin_change_character:

    call man_entity_change_character_1  ;;modificamos el sprite del jugador 1
    ret 


    back_menu:

    pop hl                              ;;quitamos la dir de memoria a la que queria hacer ret
    ld  hl, #game_restart               ;;metemos en hl la dir de mem para que vuelva al menu inicial
    push hl                             ;;metemos en la pila la dir de mem a la que queremos que haga ret

    ret

