;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of 1to1 Soccer: An Amstrad CPC Game
;;  Copyright (C) 2020 Utopia (@UtopiaRetroDev)
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see http://www.gnu.org/licenses/.
;;-------------------------------------------------------------------------------

.module Controls_Manager

.include "sys/physics.h.s"
.include "cpctelera.h.s"
.include "cpct_functions.h.s"
.include "src/sprites/menus/menu_controls_z.h.s"

.globl game_restart

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; 
;; Funcion de inicializar el menu de controles
;;
;;   

man_controls_init::

    ld  hl, #_menu_controls_z_end
    ld  de, #0xFFFF 
    call cpct_zx7b_decrunch_s_asm

    ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; 
;; Funcion de actualizar el menu de controles
;;
;;   

man_controls_run::

    ld  hl, #Key_Esc
    call cpct_isKeyPressed_asm
    jr  nz, back_menu                   ;;si pulsa ESC vuelve al menu anterior
    ld  hl, #Key_1
    call cpct_isKeyPressed_asm
    jr  nz, controls_1                  ;;si esta pulsando el 1 le colocamos los controles1
    ld  hl, #Key_2
    call cpct_isKeyPressed_asm
    jr  z, man_controls_run             ;;si no se ha pulsado ninguna nos quedamos en bucle

    ld  de, #keyboard_player_1_op_2
    ld  hl, #array_key_player1          ;;cambianos en physics el array que tiene que recorrer al comprobar el teclado
    call man_controls_change_player

    ld  de, #keyboard_player_2_op_2
    ld  hl, #array_key_player2          ;;cambianos en physics el array que tiene que recorrer al comprobar el teclado
    call man_controls_change_player
    
    ret

    controls_1:

    ld  de, #keyboard_player_1_op_1
    ld  hl, #array_key_player1          ;;cambianos en physics el array que tiene que recorrer al comprobar el teclado
    call man_controls_change_player

    ld  de, #keyboard_player_2_op_1
    ld  hl, #array_key_player2          ;;cambianos en physics el array que tiene que recorrer al comprobar el teclado
    call man_controls_change_player

    ret 


    back_menu:

    pop hl                              ;;quitamos la dir de memoria a la que queria hacer ret
    ld  hl, #game_restart               ;;metemos en hl la dir de mem para que vuelva al menu inicial
    push hl                             ;;metemos en la pila la dir de mem a la que queremos que haga ret

    ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; 
;; Funcion para cambiar el contenido de la dir de mem de hl por lo que hay en de
;;
;;   

man_controls_change_player:

    ld  (hl), e
    inc hl
    ld  (hl), d

    ret