;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of 1to1 Soccer: An Amstrad CPC Game
;;  Copyright (C) 2020 Utopia (@UtopiaRetroDev)
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see http://www.gnu.org/licenses/.
;;-------------------------------------------------------------------------------

.module Entity_Manager

;; Public Functions
.globl man_entity_init
.globl man_entity_generator
.globl man_entity_create
.globl man_entity_update_forall
.globl man_entity_reset_goal
.globl man_entity_reset_out_left
.globl man_entity_reset_out_right
.globl man_entity_change_character_1
.globl man_entity_change_character_2
.globl man_entity_change_ia
.globl man_entity_getArrayHL
.globl man_entity_calculate_tile
.globl man_entity_flip_right
.globl man_entity_flip_left
.globl man_entity_getSprite_player1_DE
.globl man_entity_getSprite_player2_DE

;; Variables
.globl func_update_forall

;;constantes
.globl floor_player
.globl floor_ball

;; Entity DEFINITION MACRO
.macro DefineEntity _tipo, _cmp, _x, _y, _limit_r, _vx, _vy, _w, _h, _tw, _th, _spritePtr, _spriteArray, _ia_level
      .db   _tipo
      .db   _cmp
      .db   _x
      .db   _y
      .db   _y
      .db   _x          ;;almacena x anterior
      .db   _y          ;;almacena y anterior
      .db   _x
      .db   _limit_r
      .db   _vx
      .db   _vy
      .db   _w
      .db   _h
      .db   _tw
      .db   _th
      .dw   _spritePtr
      .dw   _spriteArray
      .dw   #0x0000     ;;almacena el tile anterior
      .db   _ia_level
.endm

;; constantes de entity para no tener que cambiar todas las posiciones de ix si cambiamos el orden de la macro de arriba
e_type = 0
e_cmp = 1
e_x = 2
e_y = 3
e_floor = 4
e_tx = 5
e_ty = 6
e_last_x = 7
e_limit_r = 8
e_vx = 9
e_vy = 10
e_w = 11
e_h = 12
e_tw = 13
e_th = 14
e_sprite_l = 15
e_sprite_h = 16
e_spriteArray_l = 17
e_spriteArray_h = 18
e_tilePos_l = 19
e_tilePos_h = 20
e_ia_level = 21

entity_size = 22
max_entities = 3

;;tipos de entidades
e_type_invalid = 0x00
e_type_player1 = 0x01
e_type_player2 = 0x02
e_type_ball = 0x04

;;tipos de componentes
e_cmp_render = 0x01     ;;entidad renderizable
e_cmp_movable = 0x02    ;;entidad que se puede mover
e_cmp_input = 0x04      ;;entidad controlable por input  
e_cmp_ia = 0x08         ;;entidad controlable con ia
e_cmp_animated = 0x10   ;;entidad animada
e_cmp_collider = 0x20   ;;entidad que puede colisionar
e_cmp_default = e_cmp_render | e_cmp_movable | e_cmp_collider  ;;componente por defecto
