;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of 1to1 Soccer: An Amstrad CPC Game
;;  Copyright (C) 2020 Utopia (@UtopiaRetroDev)
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see http://www.gnu.org/licenses/.
;;-------------------------------------------------------------------------------

;;
;; IA control Manager
;;
.module man_ia_control

.include "cpct_functions.h.s"
.include "cpctelera.h.s"
.include "comp/component.h.s"
.include "man/entity.h.s"

array_size = 1


DefineComponentArrayStructure_Size _ia, max_entities, array_size
;; Solo es uno porque solo hay una entidad con ia

ia_level_man::
.db 0

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; GET IA ARRAY
;;  coge la dir del comienzo del array y la mete en IX
;; 

man_ia_getArrayHL::
    ld  hl, #_ia_array
    ret


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; INICIALIZACION DEL MANAGER DE COLISIONES
;; 

man_ia_init::


    ld  hl, #_ia_array       ;;guardamos en hl la dir de mem del comienzo del array
    ld  (_ia_pend), hl       ;;hacemos que el puntero apunte a la primera posicion

    xor a                           ;;hacemos xor de a consigo misma para obtener un 0
    ld  (hl), a                     ;;metemos 0 en la primera pos
    ld  d, h
    ld  e, l                        ;;metemos hl en de
    inc de                          ;;empezamos a poner 0 a partir de esta posicion
    ld  bc, #array_size*max_entities-1       ;;ponemos array_size*max_entities que es el tamany del array menos 1 que es el que hemos puesto antes

    ldir


    ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; AGREGAMOS ENTIDADES AL MANAGER DE COLISIONES
;; 
;; INPUT:
;;    IX: puntero a la entidad que hay que agregar
;;

man_ia_add::

    ld e_ia_level(ix), #0x05                      ;;guardamos el ia level
    ld a, e_ia_level(ix)
    ld (ia_level_man), a

    ld  hl, (_ia_pend)   ;;metemos en hl la primera posicion libre del array
    ld__a_ixl                   ;;metemos en a la direccion de memoria inferior de ix
    ld  (hl), a                 ;;lo guardamos en hl
    inc hl                      ;;pasamos a la siguiente posicion de hl
    ld__a_ixh                   ;;metemos en a la parte superior de la dir de mem de ix
    ld  (hl), a                 ;;guardamos de nuevo ese valor en hl y ya tenemos la direccion de mem de ix almacenada

    inc hl                      ;;pasamos hl a la siguiente poscion libre
    ld  (_ia_pend), hl   ;;actualizamos el puntero a la primera posicion libre con el valor de hl

    ret