;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of 1to1 Soccer: An Amstrad CPC Game
;;  Copyright (C) 2020 Utopia (@UtopiaRetroDev)
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see http://www.gnu.org/licenses/.
;;-------------------------------------------------------------------------------

.module Menu_Manager

.include "sys/render.h.s"
.include "cpctelera.h.s"
.include "cpct_functions.h.s"
.include "man/entity.h.s"
.include "man/game.h.s"
.include "src/sprites/menus/menu_init_z.h.s"

.globl menu_controls
.globl menu_credits

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; 
;; Funcion de inicializar el menu
;;
;;   

man_menu_init::

    ;;cambiar el memory offset para que si ha acabado movido en el scroll no afecte a este
    ld   l, #0
    call cpct_setVideoMemoryOffset_asm  ;;cambiamos el offset de la memoria (donde empieza lo que se ve)

    ld  hl, #_menu_init_z_end
    ld  de, #0xFFFF 
    call cpct_zx7b_decrunch_s_asm

    ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; 
;; Funcion de actualizar el menu
;;
;;   

man_menu_run::

    ld  hl, #Key_1
    call cpct_isKeyPressed_asm          
    ld  a, #1                           ;;modo single player sera el 1
    ld  (mode_game), a    
    ret nz                              ;;si esta pulsando el 1 nos salimos

    ld  hl, #Key_2
    call cpct_isKeyPressed_asm
    jr  nz, mode_multiplayer

    ld  hl, #Key_3
    call cpct_isKeyPressed_asm
    jr  nz, mode_controls

    ld  hl, #Key_4
    call cpct_isKeyPressed_asm
    jr  z, man_menu_run                 ;;si no se ha pulsado ninguna nos quedamos en bucle
   
    pop hl                              ;;quitamos de la pila la dir de mem de donde tenemos que volver
    ld  hl, #menu_credits               ;;metemos la dir de mem de donde esta el menu de controles para que se vaya a hacerlo
    push hl                             ;;lo metemos en la pila para que vaya ahi

    ret

    mode_multiplayer:
    ld  a, #2                           ;;modo multijugador sera el 2
    ld  (mode_game), a                  
    call man_entity_change_ia           ;;modificamos para que el jugador 2 no sea ia

    ret

    mode_controls:

    pop hl                              ;;quitamos de la pila la dir de mem de donde tenemos que volver
    ld  hl, #menu_controls              ;;metemos la dir de mem de donde esta el menu de controles para que se vaya a hacerlo
    push hl                             ;;lo metemos en la pila para que vaya ahi

    ret