;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of 1to1 Soccer: An Amstrad CPC Game
;;  Copyright (C) 2020 Utopia (@UtopiaRetroDev)
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see http://www.gnu.org/licenses/.
;;-------------------------------------------------------------------------------

.module Winner_Manager

.include "sys/render.h.s"
.include "cpctelera.h.s"
.include "cpct_functions.h.s"
.include "man/game.h.s"
.include "src/sprites/sprites.h.s"
.include "src/sprites/menus/menu_winner_z.h.s"
.include "man/entity.h.s"


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; 
;; Funcion de inicializar el menu de ganador
;;
;;   

man_winner_init::

    ;;cambiar el memory offset para que si ha acabado movido en el scroll no afecte a este
    ld   l, #0
    call cpct_setVideoMemoryOffset_asm  ;;cambiamos el offset de la memoria (donde empieza lo que se ve)

    ld  hl, #_menu_winner_z_end
    ld  de, #0xFFFF 
    call cpct_zx7b_decrunch_s_asm

    ;;ver quien gana
    ld  a, (winner)                 ;;cargo quien ha ganado (1 si es jugador 1, 2 si ha ganado el 2)
    cp  #1  
    jr  z, winner_1                         
    jr  nc, winner_2                ;;si le quito 1 y no da 0 es que ha ganado el 2
    jr  c, winner_0

    winner_1:

    ld  de, #0xC000
    ld  c, #11
    ld  b, #27

    call cpct_getScreenPtr_asm

    ex  de, hl                              ;;metemos en de la dir de mem que nos devuelve la llamada anterior
    ld  hl, #_sprite_player_1
    ld  c, #34
    ld  b, #28

    call cpct_drawSprite_asm


    ;;llamamos a la func para nos de el sprite a usar 
    call man_entity_getSprite_player1_DE
    ;;metemos esa dir en el call de abajo
    ld  hl, #draw_player_1
    ld  (hl), e
    inc hl
    ld  (hl), d

    ld  de, #0xC000
    ld  c, #25
    ld  b, #115

    call cpct_getScreenPtr_asm

draw_player_1 = . + 1
    call #0x0000

    jr  wins_player

    winner_2:

    ld  de, #0xC000
    ld  c, #11
    ld  b, #27

    call cpct_getScreenPtr_asm

    ex  de, hl                              ;;metemos en de la dir de mem que nos devuelve la llamada anterior
    ld  hl, #_sprite_player_2
    ld  c, #34
    ld  b, #28

    call cpct_drawSprite_asm

    ;;llamamos a la func para nos de el sprite a usar 
    call man_entity_getSprite_player2_DE
    ;;metemos esa dir en el call de abajo
    ld  hl, #draw_player_2
    ld  (hl), e
    inc hl
    ld  (hl), d

    ld  de, #0xC000
    ld  c, #46
    ld  b, #115

    call cpct_getScreenPtr_asm

draw_player_2 = . + 1
    call #0x0000

    wins_player:

    ld  de, #0xC000
    ld  c, #49
    ld  b, #25

    call cpct_getScreenPtr_asm

    ex  de, hl
    ld  hl, #_sprite_wins
    ld  c, #19
    ld  b, #27
    call cpct_drawSprite_asm

    ret

    winner_0:

    ld  de, #0xC000
    ld  c, #23
    ld  b, #22

    call cpct_getScreenPtr_asm

    ex  de, hl                              ;;metemos en de la dir de mem que nos devuelve la llamada anterior
    ld  hl, #_sprite_draw
    ld  c, #36
    ld  b, #44

    call cpct_drawSprite_asm

    ;;llamamos a la func para nos de el sprite a usar 
    call man_entity_getSprite_player1_DE
    ;;metemos esa dir en el call de abajo
    ld  hl, #draw_player_1_empate
    ld  (hl), e
    inc hl
    ld  (hl), d

    ld  de, #0xC000
    ld  c, #25
    ld  b, #115

    call cpct_getScreenPtr_asm

draw_player_1_empate = . + 1
    call #0x0000

    ;;llamamos a la func para nos de el sprite a usar 
    call man_entity_getSprite_player2_DE
    ;;metemos esa dir en el call de abajo
    ld  hl, #draw_player_2_empate
    ld  (hl), e
    inc hl
    ld  (hl), d

    ld  de, #0xC000
    ld  c, #46
    ld  b, #115

    call cpct_getScreenPtr_asm

draw_player_2_empate = . + 1
    call #0x0000

    ret



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; 
;; Funcion de actualizar el menu de ganador
;;
;;   

man_winner_run::

    ld  hl, #Key_Space
    call cpct_isKeyPressed_asm
    jr  z, man_winner_run                 ;;si no se ha pulsado ninguna nos quedamos en bucle

    ret